"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CWidgetIcon
var CWidgetIcon = function CWidgetIcon(props) {
  var className = props.className,
      children = props.children,
      header = props.header,
      text = props.text,
      iconPadding = props.iconPadding,
      color = props.color,
      footerSlot = props.footerSlot,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "children", "header", "text", "iconPadding", "color", "footerSlot"]);

  var classes = (0, _classnames["default"])('card', color, className);
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: classes
  }, attributes), /*#__PURE__*/_react["default"].createElement("div", {
    className: "card-body d-flex align-items-center " + (iconPadding ? 'p-3' : 'p-0')
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "mr-3 text-white bg-" + color + " " + (iconPadding ? 'p-3' : 'p-4')
  }, children), /*#__PURE__*/_react["default"].createElement("div", null, header && /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-value text-" + color
  }, header), text && /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-muted text-uppercase font-weight-bold small"
  }, text))), footerSlot);
};

CWidgetIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  header: _propTypes["default"].string,
  text: _propTypes["default"].string,
  iconPadding: _propTypes["default"].bool,
  color: _propTypes["default"].string,
  footerSlot: _propTypes["default"].node
} : {};
CWidgetIcon.defaultProps = {
  iconPadding: true
};
var _default = CWidgetIcon;
exports["default"] = _default;
module.exports = exports.default;